var Just = /** @class */ (function () {
    function Just(_value) {
        this._value = _value;
        this._tag = 'Just';
    }
    return Just;
}());
var Nothing = /** @class */ (function () {
    function Nothing() {
        this._tag = 'Nothing';
    }
    return Nothing;
}());
export var just = function (value) {
    return new Just(value);
};
export var nothing = function () {
    return new Nothing();
};
export var isJust = function (value) {
    return value instanceof Just;
};
export var isNothing = function (value) {
    return value instanceof Nothing || value === null || value === undefined;
};
export var withDefault = function (value, defaultValue) {
    if (isNothing(value)) {
        return defaultValue;
    }
    else {
        return value._value;
    }
};
export var map = function (f, value) {
    if (isNothing(value)) {
        return nothing();
    }
    else {
        return just(f(value._value));
    }
};
export var map2 = function (f, a, b) {
    if (isNothing(a) || isNothing(b)) {
        return nothing();
    }
    else {
        return just(f(a._value, b._value));
    }
};
export var map3 = function (f, a, b, c) {
    if (isNothing(a) || isNothing(b) || isNothing(c)) {
        return nothing();
    }
    else {
        return just(f(a._value, b._value, c._value));
    }
};
export var map4 = function (f, a, b, c, d) {
    if (isNothing(a) || isNothing(b) || isNothing(c) || isNothing(d)) {
        return nothing();
    }
    else {
        return just(f(a._value, b._value, c._value, d._value));
    }
};
export var map5 = function (f, a, b, c, d, e) {
    if (isNothing(a) ||
        isNothing(b) ||
        isNothing(c) ||
        isNothing(d) ||
        isNothing(e)) {
        return nothing();
    }
    else {
        return just(f(a._value, b._value, c._value, d._value, e._value));
    }
};
export var mapN = function (f) {
    var a = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        a[_i - 1] = arguments[_i];
    }
    if (a.some(isNothing)) {
        return nothing();
    }
    else {
        return just(f.apply(void 0, a.map(function (v) { return v._value; })));
    }
};
export var andThen = function (f, v) {
    if (isNothing(v)) {
        return nothing();
    }
    else {
        return f(v._value);
    }
};
export var caseOf = function (caseof, value) {
    if (isNothing(value)) {
        return caseof.Nothing();
    }
    else {
        return caseof.Just(value._value);
    }
};
export var equals = function (a, b) {
    return caseOf({
        Just: function (va) {
            return caseOf({
                Just: function (vb) { return va === vb; },
                Nothing: function () { return false; }
            }, b);
        },
        Nothing: function () {
            return caseOf({
                Just: function (vb) { return false; },
                Nothing: function () { return true; }
            }, b);
        }
    }, a);
};
